package com.wx.one;

import cn.hutool.crypto.digest.DigestUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.wx.WxAccessEntity;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

@RestController
@RequestMapping
public class WxTestOneController {

    public static String TOKEN = "hahaha";

    @RequestMapping("/test")
    public String fun01(@RequestParam("signature") String signature,
                     @RequestParam("timestamp") String timestamp,
                     @RequestParam("nonce") String nonce,
                     @RequestParam("echostr") String echostr) {
        List<String> list = Arrays.asList(TOKEN, timestamp, nonce);
        Collections.sort(list);
        String joinStr = StringUtils.join(list, "");
        String s1 = DigestUtil.sha1Hex(joinStr);
        if (s1.equals(signature)) {
            return echostr;
        }
        return null;
    }

    @PostMapping("/test")
    public String fun02() {
        return "rr";
    }

    private static String appId = "wx26376bb80b8541c2";

    private static String appsecret = "a34f2006fcf0ce1ce1bb9b2ca5d26591";

    public static void main(String[] args) {
        WxAccessEntity wxAccessEntity = getWxAccessToken(appId, appsecret);
        // 存入redis
        System.out.println(wxAccessEntity);
    }

    public static WxAccessEntity getWxAccessToken(String appId, String appsecret) {
        Assert.hasText(appId, "appId不允许为空");
        Assert.hasText(appsecret, "appsecret不允许为空");
        String url = String.format("https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=%s&secret=%s", appId, appsecret);
        String response = HttpUtil.get(url);
        JSONObject jsonObject = JSON.parseObject(response);
        return new WxAccessEntity()
                .setAccessToken(String.valueOf(jsonObject.get("access_token")))
                .setExpiresIn((Integer) jsonObject.get("expires_in"));
    }

}
